routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('cekakun')->group(function () {
    Route::get('/', "Dashboard\DashboardController@index")->name('dashboard');
    Route::get('test_word/{id}', "Dashboard\DashboardController@testWord");
    Route::resource("jabatan","DataMaster\JabatanController");
    Route::resource("tempat_tugas","DataMaster\TipePegawaiController");
    Route::resource("tempat_presensi","Presensi\TempatPresensiController");
    Route::resource("pegawai","Pengguna\PegawaiController");
    Route::resource("akun","Pengguna\AkunController");
    Route::get("all_pegawai","Pengguna\PegawaiController@all_pegawai");
    Route::resource('rule_presensi','Presensi\RulePresensiController');
    Route::resource('waktu_presensi','Presensi\WaktuPresensiController');
    Route::resource('rule_hari_libur','Presensi\RuleHariLiburController');
    Route::get("logout","Auth\LoginController@logout")->name('logout');
    Route::resource('belum_presensi', 'Presensi\BelumPresensiController');
    Route::resource('log_presensi', 'Presensi\PresensiController');
    Route::get('log_presensi/group/{tipe}','Presensi\PresensiController@showPerTempatTugas');
    Route::post('print_data', 'Presensi\PresensiController@rekapData');
    Route::get('detail_presensi/{pegawai}','Presensi\PresensiController@detailPresensi');
    // Cetak Data
    Route::get('printData','Presensi\PresensiController@printData');
    Route::post('print_data_kolektif', 'Presensi\PresensiController@rekapDataKolektif');
    Route::get('cetak_pdf_kolektif/{pegawai}','Presensi\PresensiController@printDataCollective');
    Route::post('cetak_pdf_all_kolektif','Presensi\PresensiController@cetakAllPegawai');
    Route::get('print_pdf_all_kolektif/{tipe}','Presensi\PresensiController@printDataAll');
    Route::get('presensi_excel/{id}','Presensi\PresensiController@exportExcel');
    //Route::get('log_presensi_pegawai/{id}','Presensi\PresensiController@show');
    Route::post('ketidakhadiran/add', 'Presensi\KetidakhadiranController@addIzin');
    Route::resource('ketidakhadiran', 'Presensi\KetidakhadiranController');
    Route::get('pengajuan_izin_cuti/{idpegawai}/{presensiid}','Presensi\KetidakhadiranController@cetakPengajuanCutiIzin');
    Route::resource('periode','Presensi\PeriodeController');
    Route::post('surat/act','Penugasan\TugasController@update');

    // Penugasan
    Route::get('penugasan/rekap', 'Penugasan\TugasController@rekap');
    Route::get('penugasan/cetak_pdf', 'Penugasan\TugasController@cetakPdf');
    Route::get('penugasan/export_excel', 'Penugasan\TugasController@export_excel');
    Route::resource('penugasan','Penugasan\TugasController');
    Route::get('penugasan/detail/{id}', 'Penugasan\TugasController@detail');
    Route::put('penugasan/detail/batal', 'Penugasan\TugasController@batal');
    Route::put('penugasan/detail/kirim', 'Penugasan\TugasController@kirim');
    Route::put('penugasan/detail/selesai', 'Penugasan\TugasController@selesai');
    Route::resource('surat','Penugasan\SuratController');
    Route::resource('aktivitas','Penugasan\AktivitasController');
    Route::get('aktifitas/rekap', 'Penugasan\AktivitasController@rekap');
    Route::get('aktifitas/cetak_pdf', 'Penugasan\AktivitasController@cetakPdf');
    Route::get('aktifitas/export_excel', 'Penugasan\AktivitasController@export_excel');
    Route::get("cek/{tgl1}/{tgl2}/{pegawai}", function($tgl1, $tgl2, $pegawai){
        $status = "accepted";
        $cek = \App\Presensi::where('presensi.pegawai_id',$pegawai)
            ->where('presensi.tipe_izin','<>',null)
            ->where('presensi.status_izin',$status)
            ->where('presensi.tipe_izin', 'dinas_luar')
            ->whereBetween('presensi.tgl_presensi',array($tgl1, $tgl2))
            ->count();
        echo $cek;
    });
});

Route::middleware('sudahlogin')->group(function () {
    Route::get("login","Auth\LoginController@showLoginForm")->name('login');
    Route::post("post_login","Auth\LoginController@post_login")->name('post_login');
});

app/Http/Controllers/Penugasan/AktivitasController.php
<?php

namespace App\Http\Controllers\Penugasan;

use App\Aktivitas;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Carbon\Carbon;
use PDF;
use Maatwebsite\Excel\Facades\Excel;
use App\ExportExcel\AktivitasExport;

class AktivitasController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $aktivitas = Aktivitas::groupBy('tanggal')->orderBy('tanggal','desc')->get();
        return view("penugasan.aktivitas.index",compact("aktivitas"));
    }

    public function rekap(Request $request)
    {
        $tahun = $request->tahun;
        $bulan = $request->bulan;
        $aktivitas = Aktivitas::whereMonth('tanggal',$bulan)
            ->whereYear('tanggal',$tahun)
            ->get()
            ->unique('pegawai_id');
        return view("penugasan.aktivitas.rekap",compact("aktivitas"));
    }

    public function cetakPdf(Request $request)
    {
        $tahun = $request->tahun;
        $bulan = $request->bulan;
        if($tahun == "" && $bulan == ""){
            $aktifitas = Aktivitas::join('pegawai','pegawai.id_pegawai','=','aktivitas.pegawai_id')
                        ->OrderBy('pegawai.nama')
                        ->get();
        }else{
            $aktifitas = Aktivitas::join('pegawai','pegawai.id_pegawai','=','aktivitas.pegawai_id')
                        ->OrderBy('pegawai.nama')
                        ->whereMonth('tanggal',$bulan)
                        ->whereYear('tanggal',$tahun)
                        ->get();
        }
        $pdf = PDF::loadView('penugasan.aktivitas.rekap.akt_pdf',
                ['aktifitas' => $aktifitas, 'bulan' => $bulan, 'tahun' => $tahun])
                ->setPaper('a4');
        return $pdf->download('Rekap_aktifitas_Bulan_'.$bulan.'_Tahun_'.$tahun.'.pdf');
    }

    public function export_excel(Request $request)
	{
        $tahun = $request->tahun;
        $bulan = $request->bulan;
		return Excel::download(new AktivitasExport($bulan, $tahun), 'Data_Aktivitas_'.'.xlsx');
	}

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($tgl)
    {
        $aktivitas = Aktivitas::join('pegawai','pegawai.id_pegawai','=','aktivitas.pegawai_id')
            ->where('aktivitas.tanggal',$tgl)->get();
        return view("penugasan.aktivitas.show",compact("aktivitas"));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Penugasan/SuratController.php
<?php

namespace App\Http\Controllers\Penugasan;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDF;
use App\Pegawai;
use App\Surattugas;

class SuratController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $title = "Surat Tugas";
        $pegawai = Pegawai::all();
        return view("penugasan.surat.index",compact("title","pegawai"));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $message = [
            'required' => ':attribute wajib diisi!!!',
        ];
        $this->validate($request,[
                'no_surat' => 'required',
        ], $message);
        $input = $request->all();
        $no_surat = $request->no_surat;
        $menimbang = $request->menimbang;
        $dasar = $request->dasar;
        $tempat_tugas = $request->tempat_tugas;
        $perihal = $request->perihal;
        $tgl_berangkat = $request->tgl_berangkat;
        $keterangan = $request->keterangan;
        $atas_nama = $request->atas_nama;
        $tembusan = $request->tembusan;
      
        $fileName = 'Surat_Tugas_'.$no_surat.'.pdf';
        $pdf = PDF::loadView('penugasan.surat.cetak',
            ['no_surat'=>$no_surat,'pegawai' => $input['pegawai_id'],'menimbang'=>$menimbang,'dasar'=>$dasar,'perihal'=>$perihal,'tempat_tugas'=>$tempat_tugas,'tgl_berangkat'=>$tgl_berangkat,'keterangan'=>$keterangan,'atas_nama'=>$atas_nama,'tembusan'=>$tembusan])
            ->setPaper('a4');
        $pdf->save('files/surattugas/'.$fileName);

        for($i = 0; $i < count($input['pegawai_id']); $i++){
            // $this->sendNotification($input['pegawai_id'][$i],$request->no_surat);
            Surattugas::create($request->except(['pegawai_id','file'])+[
                'pegawai_id' => $input['pegawai_id'][$i],
                'file' => $fileName 
            ]);
        }
        return redirect("penugasan")->with('success', 'Berhasil Menambah Penugasan');;
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/penugasan/tugas/create_edit.blade.php
@extends('templates.main')
@section('title', $title)
@section('content')			
    <div class="row justify-content-center">
        <div class="col-md-12">
            <nav aria-label="breadcrumb" class="mb-2">
                <ol class="breadcrumb p-0">
                  <li class="breadcrumb-item">
                    <a href="{{ url("/") }}">
                      <span class="mdi mdi-home"></span>                
                    </a>
                  </li>
                  <li class="breadcrumb-item">
                    <a href="{{ route("penugasan.index") }}">Daftar Penugasan             
                    </a>
                  </li>
                  <li class="breadcrumb-item text-success" aria-current="page">
                    @if($page == "edit")Edit @else Tambah @endif Penugasan
                  </li>
                </ol>
            </nav>
            <div class="card card-default">
                <div class="card-header card-header-border-bottom">
                    <h2>Surat Tugas - Dinas Luar</h2>
                </div>
                <div class="card-body">
                    <form action="{{route('surat.store')}}" method="post">
                    @csrf
                    <div class="row">
                        <div class="col-6">
                        <div class="form-group">
                            <label>Nomor Surat</label>
                            <input type="text" name="no_surat" class="form-control @error('no_surat') is-invalid @enderror" 
                                placeholder="ex. Kw.13.1/1234/Kp/03.1/29/3/2021"/>
                            @error('no_surat')
                            <div class="invalid-feedback">
                                {{ $message }}  
                            </div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label>Tempat Tugas</label>
                            <input type="text" name="tempat_tugas" class="form-control @error('tempat_tugas') is-invalid @enderror"  />
                            @error('tempat_tugas')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror    
                        </div>
                        <div class="form-group">
                            <label>Keterangan</label>
                            <input type="text" name="keterangan" class="form-control @error('keterangan') is-invalid @enderror" />
                            @error('keterangan')
                            <div class="invalid-feedback">
                                {{ $message }}  
                            </div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label>Tembusan</label>
                            <input type="text" name="tembusan" class="form-control @error('tembusan') is-invalid @enderror"  />
                            @error('tembusan')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror    
                        </div>
                        </div>
                        <div class="col-6">
                        <div class="form-group">
                            <label>Pegawai</label>
                            <select multiple class="selectpicker form-control @error('pegawai_id') is-invalid @enderror" data-live-search="true" name="pegawai_id[]">
                                <option value="">Pilih Pegawai</option>
                                @foreach ($pegawai as $item)
                                    <option value="{{ $item->id_pegawai }}">{{ $item->nama }} </option>
                                @endforeach
                            </select>
                            @error('pegawai_id')
                            <div class="invalid-feedback">
                                {{ $message }}  
                            </div>
                        @enderror 
                        </div>
                        <div class="form-group">
                            <label>Tanggal Berangkat</label>
                            <input type="date" name="tgl_berangkat" class="form-control @error('tgl_berangkat') is-invalid @enderror" />
                            @error('tgl_berangkat')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror    
                        </div>
                        <div class="form-group">
                            <label>Tanggal Kembali</label>
                            <input type="date" name="tgl_kembali" class="form-control @error('tgl_kembali') is-invalid @enderror" />
                            @error('tgl_kembali')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror    
                        </div>
                        <div class="form-group">
                            <label>Jenis Angkutan</label>
                            <select class="form-control @error('jenis_angkutan') is-invalid @enderror" name="jenis_angkutan">
                                <option value="">Pilih Jenis Angkutan</option>
                                <option value="Dinas">Dinas</option>
                                <option value="Umum">Umum</option>
                                <option value="Pribadi">Pribadi</option>
                            </select>
                            @error('jenis_angkutan')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror    
                        </div>
                        <div class="form-group">
                            <label>Jenis Tugas</label>
                            <select class="form-control @error('jenis_tugas') is-invalid @enderror" name="jenis_tugas">
                                <option value="">Pilih Jenis Tugas</option>
                                <option value="Luar Kota">Luar kota</option>
                                <option value="Dalam kota">Dalam Kota</option>
                            </select>
                            @error('jenis_tugas')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror    
                        </div>
                        </div>
                        </div>
                        <div class="form-group">
                        <label>Menimbang</label>
                            <textarea class="form-control" id="menimbang" name="menimbang"></textarea>
                        </div>
                        <div class="form-group">
                        <label>Dasar</label>
                            <textarea class="form-control" id="dasar" name="dasar"></textarea>
                        </div>
                        <div class="form-group">
                        <label>Perihal</label>
                            <textarea class="form-control" id="perihal" name="perihal"></textarea>
                        </div>
                        <div class="form-group">
                        <label>Atas Nama</label>
                            <textarea class="form-control" id="an" name="atas_nama"></textarea>
                        </div>
                        <div class="form-footer pt-4 pt-5 mt-4 border-top">
                            <button type="submit" class="btn btn-primary btn-default">Cetak</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/penugasan/tugas/rekap.blade.php
@extends('templates.main')
@section('title','Halaman Penugasan')
@section('content')			
    <div class="row justify-content-center">
        <div class="col-md-12">
            <nav aria-label="breadcrumb" class="mb-2">
                <ol class="breadcrumb p-0">
                  <li class="breadcrumb-item">
                    <a href="{{ url("/") }}">
                      <span class="mdi mdi-home"></span>                
                    </a>
                  </li>
                  <li class="breadcrumb-item text-success" aria-current="page">
                    Penugasan Pegawai
                  </li>
                </ol>
            </nav>
            <div class="card card-default">
                <div class="card-header card-header-border-bottom">
                    <h2>Data Penugasan Pegawai</h2>
                </div>
                <div class="card-body">
                    @if(Session::has('success'))
                        <div class="alert alert-dismissible fade show alert-success" role="alert">
                            {{ Session::get("success") }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">×</span>
                            </button>
                        </div>
                    @endif
                    <div class="row">
                        <div class="col-md-6">
                            <form action="{{ url('penugasan/rekap') }}" method="GET">
                                <div class="row">
                                    <div class="form-group mr-2">
                                        <label>Tahun</label>
                                        <select class="form-control years" name="tahun"></select>
                                    </div>
                                    <div class="form-group">
                                        <label>Bulan</label>
                                        <div class="input-group">
                                            <select class="form-control months" name="bulan"></select>
                                            <div class="ml-3">
                                                <button class="btn btn-primary" type="submit">Rekap</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="col-md-6">
                            <div class="mt-4">
                                <a href="{{ url('penugasan/cetak_pdf?tahun='.Request::query('tahun').'&bulan='. Request::query('bulan')) }}" class="btn btn-primary">Rekap PDF</a>
                                <a href="{{ url('penugasan/export_excel?tahun='.Request::query('tahun').'&bulan='. Request::query('bulan'))}}" class="btn btn-primary">Rekap Excel</a>
                            </div>
                        </div>
                    </div>
                    <a href="{{ route('penugasan.create') }}" class="btn btn-success btn-pill mb-3">Tambah Penugasan</a>
                    <div class="basic-data-table">
                        <table id="data" class="table nowrap" style="width:100%">
                            <thead>
                                <tr>
                                    <td>No</td>
                                    <td>Tanggal Tugas</td>
                                    <td>Dasar Pelaksanaan</td>
                                    <td>Perihal</td>
                                    <td>Tempat</td>
                                    <td>Pegawai</td>
                                    <td>Status</td>
                                    <td?>File</td?>
                                    <td>Aksi</td>
                                </tr>
                            </thead>
                            <tbody>
                                @php $no = 0; @endphp
                                @foreach ($penugasan as $item) @php $no++; @endphp
                                    <tr>
                                        <td>{{ $no }}</td>
                                        <td>{{ $item->tgl_berangkat}} - {{$item->tgl_kembali }}</td>
                                        <td>{{$item->no_surat}}</td>
                                        <td>{{$item->perihal}}</td>
                                        <td>{{$item->tempat_tugas}}</td>
                                        <td>
                                            @for($i = 0; $i < count(getNamaPegawai($item->no_surat)); $i++  )
                                                {{ getNamaPegawai($item->no_surat)[$i].", " }}
                                            @endfor
                                        </td>
                                        <td>{{$item->status}}</td>
                                        <td>{{$item->file}}</td>
                                        <td>
                                            <a href="{{ route("penugasan.edit",$item->id) }}" class="btn btn-primary btn-sm">
                                                <i class="fas fa-edit"></i>
                                            </a>
                                            <button type="button" data-toggle="modal" data-target="#exampleModal{{ $item->id }}" 
                                                class="btn btn-danger btn-sm">
                                                <i class="fas fa-trash"></i>
                                            </button>
                                        </td>
                                    </tr>

                                    <div class="modal fade" id="exampleModal{{ $item->id }}" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title" id="exampleModalLabel">Hapus Data</h5>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">×</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    Apakah Penugasan {{ $item->no_surat }} akan dihapus ?
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-danger btn-pill" data-dismiss="modal">Tidak</button>
                                                    <form action="{{ route('penugasan.destroy', $item->no_surat) }}" method="post"> 
                                                        @csrf
                                                        @method('DELETE')    
                                                        <button type="submit" class="btn btn-primary btn-pill">Ya</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection